/******************************************************************************
 *  CVS version:
 *     $Id: $
 ******************************************************************************
 *
 *  C header file : general.h
 *  Project       : Alan Compiler
 *  Version       : 1.0 alpha
 *  Description   : Generic definitions
 *
 *  Comments: (in Greek iso-8859-7)
 *  ---------
 *    .
 *       .
 *      .
 *    
 */


#ifndef __GENERAL_H__
#define __GENERAL_H__


/* ---------------------------------------------------------------------
   ---------------------------- Header files ---------------------------
   --------------------------------------------------------------------- */

#include <stdbool.h>
#include <stdlib.h>


/* ---------------------------------------------------------------------
   --------------------------- Generic flags ---------------------------
   --------------------------------------------------------------------- */

extern bool flagVerbose;


/* ---------------------------------------------------------------------
   -------------     -------------
   --------------------------------------------------------------------- */

void terminate (int);


/* ---------------------------------------------------------------------
   -----------      ------------
   --------------------------------------------------------------------- */

void * new    (size_t);
void   delete (void *);


/* ---------------------------------------------------------------------
   -------        --------
   --------------------------------------------------------------------- */

extern char * filename;
extern int linecount;


/* ---------------------------------------------------------------------
   ---------------------------  ---------------------------
   --------------------------------------------------------------------- */

typedef struct Identifier_tag * Identifier;

Identifier id_make (const char *);
const char * id_name (Identifier);

void id_reset ();


#endif
