/******************************************************************************
 *  CVS version:
 *     $Id: $
 ******************************************************************************
 *
 *  C code file : types.c
 *  Project     : Alan Compiler
 *  Version     : 1.0 alpha
 *  Description : Types
 *
 *  Comments: (in Greek iso-8859-7)
 *  ---------
 *    .
 *       .
 *      .
 *    
 */


/* ---------------------------------------------------------------------
   ---------------------------- Header files ---------------------------
   --------------------------------------------------------------------- */

#include "types.h"


/* ---------------------------------------------------------------------
   ---------------------   -------------------------
   --------------------------------------------------------------------- */

Type type_int ()
{
   Type result = new(sizeof(struct Type_tag));

   result->kind = TYPE_int;
   return result;
}

Type type_byte ()
{
   Type result = new(sizeof(struct Type_tag));

   result->kind = TYPE_byte;
   return result;
}

Type type_array (Type type)
{
   Type result = new(sizeof(struct Type_tag));

   result->kind = TYPE_array;
   result->elType = type;
   return result;
}

Type type_proc ()
{
   Type result = new(sizeof(struct Type_tag));

   result->kind = TYPE_proc;
   return result;
}

unsigned int sizeOfType (Type type)
{
   switch (type->kind) {
      case TYPE_int:
         return 2;
      case TYPE_byte:
         return 1;
      case TYPE_array:
         return type->size * sizeOfType(type->elType);
      default:
         return 0;
   }
}

bool equalType (Type type1, Type type2)
{
   if (type1->kind != type2->kind)
      return false;
   switch (type1->kind) {
      case TYPE_array:
         return equalType(type1->elType, type2->elType);
      default:
         return true;        
   }
}
