/******************************************************************************
 *  CVS version:
 *     $Id: $
 ******************************************************************************
 *
 *  C header file : types.h
 *  Project       : Alan Compiler
 *  Version       : 1.0 alpha
 *  Description   : Types
 *
 *  Comments: (in Greek iso-8859-7)
 *  ---------
 *    .
 *       .
 *      .
 *    
 */


#ifndef __TYPES_H__
#define __TYPES_H__


/* ---------------------------------------------------------------------
   ---------------------------- Header files ---------------------------
   --------------------------------------------------------------------- */

#include <stdbool.h>

#include "general.h"


/* ---------------------------------------------------------------------
   -------------------------   -----------------------------
   --------------------------------------------------------------------- */

/*  */

typedef struct Type_tag * Type;


/*   */

struct Type_tag {
   enum {                               /*****     ****/
      TYPE_int,                         /* int                       */
      TYPE_byte,                        /* byte                      */
      TYPE_array,                       /* array type                */
      TYPE_proc                         /* proc (return type)        */
   } kind;
   Type elType;                         /* element's type, if array  */
   unsigned int size;                   /* size of array, if known   */
                                        /*    zero otherwise         */
};



/* ---------------------------------------------------------------------
   ---------------------   -------------------------
   --------------------------------------------------------------------- */

Type type_int   ();
Type type_byte  ();
Type type_array (Type t);
Type type_proc  ();

unsigned int  sizeOfType (Type type);
bool          equalType  (Type type1, Type type2);


#endif
